local setmetatable = setmetatable
local pairs = pairs

module (...)

Exports = {
	tbSelect = 0,
	tbDraw = 0,
	tbErase = 0,
	tbStamp = 0,
	tbFill = 0,
	tbNewObject = 0,
	tbNewBackdrop = 0,
}

Layer = {
	tempdata = { },
	controls = { },
	tools = { },
	clipboard = nil,
	
	queuedUpdate = false,
	name = '',
	layerType = 0,
	layerName = '',
	order = 0,
	cursor = 'win',
	curTool = '',
}

function LayerObject (obj)
	return Layer:new(obj)
end

function Layer:new (obj)
	obj = obj or {}
	setmetatable (obj, self)
	self.__index = self
	obj:Construct()
	return obj
end

function Layer:Construct ()
	self.controls = { }
	self.tools = { }
end

function Layer:Init () end

function Layer:Activate () end

function Layer:Deactivate () end

function Layer:Reset () end

function Layer:TileProperties ()
	return { }
end

function Layer:OpenProperties () end

function Layer:QueueUpdateProperties ()
	self.queuedUpdate = true
end

function Layer:UpdateProperties () end

function Layer:UpdateControls () 
	for k,v in pairs(self.controls) do
		v:Update()
	end
end

function Layer:StepControls () 
	for k,v in pairs(self.controls) do
		v:Step()
	end
end

function Layer:UpdateTools () end

function Layer:Step() end

function Layer:Redraw () end

function Layer:Cut () end

function Layer:Copy () end

function Layer:Paste () end

function Layer:Undo () end

function Layer:Redo () end