local require = require

module (...)

-- ----------------------------------------------------------------------------

BaseLayer = require "./lua/editor_baselayer"
TileLayer = require "./lua/editor_tilelayer"
ObjectLayer = require "./lua/editor_objectlayer"
BackdropLayer = require "./lua/editor_backlayer"

-- ----------------------------------------------------------------------------

function LayerObject (obj)
	return BaseLayer.Layer:new(obj)
end

function TileLayerObject (obj)
	return TileLayer.Layer:new(obj)
end

function ObjectLayerObject (obj)
	return ObjectLayer.Layer:new(obj)
end

function BackdropLayerObject (obj)
	return BackdropLayer.Layer:new(obj)
end

-- ----------------------------------------------------------------------------

function BindConf (conf)
	BaseLayer.Conf = conf
	TileLayer.Conf = conf
	ObjectLayer.Conf = conf
	BackdropLayer.Conf = conf
end

function BindControls (controls)
	BaseLayer.Controls = controls
	TileLayer.Controls = controls
	ObjectLayer.Controls = controls
	BackdropLayer.Controls = controls
end

function BindCursor (cursor)
	BaseLayer.Cursor = cursor
	TileLayer.Cursor = cursor
	ObjectLayer.Cursor = cursor
	BackdropLayer.Cursor = cursor
end

function BindFixedTable (fixed)
	BaseLayer.FixedTable = fixed
	TileLayer.FixedTable = fixed
	ObjectLayer.FixedTable = fixed
	BackdropLayer.FixedTable = fixed
end

function SetCurrent (layer)
	BaseLayer.Current = layer
	TileLayer.Current = layer
	ObjectLayer.Current = layer
	BackdropLayer.Current = layer
end

